// MPEGDecControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tulsa sample app.h"
#include "FrameListDlg.h"
#include "MPEGDecControlDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define STATUS_UPDATE_PERIOD	500		// Time in ms between status updates

#define STATUS_EVENT			1		// ID of the timer event used for 


static PANEL_IDS CardIDs[NUM_SUB_COMMANDS] = {
	{IDC_PLAY_1, IDC_STOP_1, IDC_PAUSE_1, IDC_LOOP_1, IDC_OPEN_1, IDC_FILE_1, 
		IDC_CHAN_STATUS_1, IDC_CHAN_LABEL1, IDC_PLAY_MODE_1, IDC_START_MODE_1,
		IDC_START_OFFSET_TYPE_1, IDC_START_OFFSET_HI_1, IDC_START_OFFSET_LO_1,
		IDC_END_OFFSET_TYPE_1, IDC_END_OFFSET_HI_1, IDC_END_OFFSET_LO_1,
		IDC_TRANS_BOS_1, IDC_TRANS_BEOS_1, IDC_TRANS_FRAMES_1, IDC_START_TIME_1,
		IDC_AUDIO_STREAM_ID_1},
	{IDC_PLAY_2, IDC_STOP_2, IDC_PAUSE_2, IDC_LOOP_2, IDC_OPEN_2, IDC_FILE_2, 
		IDC_CHAN_STATUS_2, IDC_CHAN_LABEL2, IDC_PLAY_MODE_2, IDC_START_MODE_2,
		IDC_START_OFFSET_TYPE_2, IDC_START_OFFSET_HI_2, IDC_START_OFFSET_LO_2,
		IDC_END_OFFSET_TYPE_2, IDC_END_OFFSET_HI_2, IDC_END_OFFSET_LO_2,
		IDC_TRANS_BOS_2, IDC_TRANS_BEOS_2, IDC_TRANS_FRAMES_2, IDC_START_TIME_2,
		IDC_AUDIO_STREAM_ID_2}};

static BOOL bInUpdateStatus = FALSE;

BEGIN_MESSAGE_MAP(CMPEGDecControlDlg, CDialog)
	//{{AFX_MSG_MAP(CMPEGDecControlDlg)
	ON_BN_CLICKED(IDC_PLAY_1, OnPlay1)
	ON_BN_CLICKED(IDC_STOP_1, OnStop1)
	ON_BN_CLICKED(IDC_PAUSE_1, OnPause1)
	ON_BN_CLICKED(IDC_LOOP_1, OnLoop1)
	ON_BN_CLICKED(IDC_PLAY_2, OnPlay2)
	ON_BN_CLICKED(IDC_STOP_2, OnStop2)
	ON_BN_CLICKED(IDC_PAUSE_2, OnPause2)
	ON_BN_CLICKED(IDC_LOOP_2, OnLoop2)
	ON_BN_CLICKED(IDC_FRAME_LIST_A, OnFrameListA)
	ON_BN_CLICKED(IDC_FRAME_LIST_B, OnFrameListB)
	ON_BN_CLICKED(IDC_OPEN_1, OnOpen1)
	ON_BN_CLICKED(IDC_OPEN_2, OnOpen2)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_CARD_STATUS, UpdateStatus)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dialog class constructors/destructors
/////////////////////////////////////////////////////////////////////////////
CMPEGDecControlDlg::CMPEGDecControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMPEGDecControlDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMPEGDecControlDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_pMpegStatus = NULL;
	m_TimerID = 0;

	for (int i = 0; i < NUM_SUB_COMMANDS; i++) {
		m_hStream[i] = 0;
		m_bFrameListEnabled[i] = FALSE;
		m_FrameListCount[i] = 0;
	}

	hBitmapPlay = NULL;
	hBitmapPlayDisabled = NULL;
	hBitmapStop = NULL;
	hBitmapStopDisabled = NULL;
	hBitmapPause = NULL;
	hBitmapPauseDisabled = NULL;
	hBitmapMuteOff = NULL;
	hBitmapMuteOn = NULL;
	hBitmapOpen = NULL;
	hBitmapLoop = NULL;
}


void CMPEGDecControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMPEGDecControlDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}



/////////////////////////////////////////////////////////////////////////////
// Initialize the dialog box
/////////////////////////////////////////////////////////////////////////////
BOOL CMPEGDecControlDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CWinApp* pApp = AfxGetApp();

	char szBuffer[60];
	strcpy(m_ClipPath[0], pApp->GetProfileString("Settings", PrependCardID(szBuffer, "ClipPath0"), ""));
	strcpy(m_ClipPath[1], pApp->GetProfileString("Settings", PrependCardID(szBuffer, "ClipPath1"), ""));

	for (int i = 0; i < NUM_SUB_COMMANDS; i++) {
		m_PlayOptions[i].PlayMode = PLAY_BOTH;
		m_PlayOptions[i].StartMode = START_NOW;
		m_PlayOptions[i].StartTime = 0;
		m_PlayOptions[i].AudioStreamID = 0;
		m_PlayOptions[i].StartOffset.Type = OFFSET_POS;
		m_PlayOptions[i].StartOffset.hi = 0;
		m_PlayOptions[i].StartOffset.lo = 0;
		m_PlayOptions[i].EndOffset.Type = OFFSET_POS;
		m_PlayOptions[i].EndOffset.hi = 0;
		m_PlayOptions[i].EndOffset.lo = 999999999;
		m_PlayOptions[i].TransitionOptions.bBlankOnStartup = FALSE;
		m_PlayOptions[i].TransitionOptions.bBlankOnEOS = FALSE;
		m_PlayOptions[i].TransitionOptions.TransitionFrames = 0;
		m_PlayOptions[i].bLoopPlay = 0;
	}

									// Setup & update the control panel for this card
	LoadCardButtonBitmaps();
	for (i = 0; i < NUM_SUB_COMMANDS; i++) {
		InitCardButtons(CG_IDD_CARD1CONTROL, CG_ID_VIEW_CARD1CONTROL, &CardIDs[i], i);
		ShowClipName(i);			
		SetPlayMode(i, m_PlayOptions[i].PlayMode);
		SetPlayMode(i, m_PlayOptions[i].StartMode);
		SetStartOffset(i, &m_PlayOptions[i].StartOffset);
		SetEndOffset(i, &m_PlayOptions[i].EndOffset);
		SetStartTime(i, m_PlayOptions[i].StartTime);
		SetAudioStreamID(i, m_PlayOptions[i].AudioStreamID);
		SetTransitionOptions(i, &m_PlayOptions[i].TransitionOptions);
	}

	InitButtonStates();

	if (m_pMpegStatus) {
		m_pMpegStatus->m_pParent = this;
	}

	m_TimerID = SetTimer(STATUS_EVENT, STATUS_UPDATE_PERIOD, NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/////////////////////////////////////////////////////////////////////////////
// Cleanup on closing of dialog box
/////////////////////////////////////////////////////////////////////////////
BOOL CMPEGDecControlDlg::DestroyWindow() 
{
	UnLoadCardButtonBitmaps();
	
	if (m_TimerID) {
		KillTimer(m_TimerID);
	}

	if (m_pMpegStatus) {
		m_pMpegStatus->m_pParent = NULL;
	}
	
	return CDialog::DestroyWindow();
}

/////////////////////////////////////////////////////////////////////////////
// Handle timer notification for dialog updates
/////////////////////////////////////////////////////////////////////////////
void CMPEGDecControlDlg::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == STATUS_EVENT) {
		UpdateStatus(0, 0);
	}
	
	CDialog::OnTimer(nIDEvent);
}

/////////////////////////////////////////////////////////////////////////////
// Update the dialog box
/////////////////////////////////////////////////////////////////////////////
LRESULT CMPEGDecControlDlg::UpdateStatus(WPARAM wParam, LPARAM lParam)
{
	DECODE_STATUS DecodeStatus;
	char szBuffer[150];
	char *pstr;

	if (m_hWnd == NULL) {	
		return 0;								// Not visible yet
	}

	if (bInUpdateStatus) {
		return 0;
	}

	if (pMPEGDecoderControl == NULL) {
		return 0;
	}

	bInUpdateStatus = TRUE;


	for (int i = 0; i < NUM_SUB_COMMANDS; i++) {
		if (m_hStream[i] == 0) {
			continue;
		}
		if (pMPEGDecoderControl->GetStatus(m_hStream[i], &DecodeStatus) != SUCCESS) {
												// Stream not available - assume it has stopped
			DecodeStatus.State = STATE_STOPPED;
		}			
		switch (DecodeStatus.State) {
		case STATE_STOPPED:
			pstr = "Stopped";
			SetButtonsToStopState(i);
			break;
		case STATE_STOP_REQUESTED:
			pstr = "Stop requested";
			break;
		case STATE_PLAY_REQUESTED:
			pstr = "Play requested";
			break;
		case STATE_PLAY_PENDING:
			pstr = "Play pending";
			break;
		case STATE_PAUSE_REQUESTED:
			pstr = "Pause requested";
			break;
		case STATE_RESUME_REQUESTED:
			pstr = "Resume requested";
			break;
		case STATE_PLAYING:
		case STATE_PAUSED:
			if (DecodeStatus.State == STATE_PLAYING) {
				pstr = "Playing";
			} else {
				pstr = "Paused";
			}

			if (StatusUnits == UNITS_TIME) {
				sprintf(szBuffer, "%s: %lu s", pstr, DecodeStatus.OffsetTime.lo/90000);
			} else if (StatusUnits == UNITS_POS) {
				sprintf(szBuffer, "%s: %lu bytes", pstr, DecodeStatus.OffsetPos.lo);
			} else {
				sprintf(szBuffer, "%s: Starting Vertical %lu  Current Frame %lu, ", pstr, DecodeStatus.StartingVertical, DecodeStatus.OffsetFrame.lo);
			}
			pstr = szBuffer;
			break;
		case STATE_ERROR:
			pstr = "Error";
			break;
		case STATE_UNKNOWN:
		default:
			pstr = "Unknown";
			break;
		}
		SetDlgItemText(CardIDs[i].StatusControl, pstr); 
	}

	bInUpdateStatus = FALSE;

	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// Command handlers...
/////////////////////////////////////////////////////////////////////////////

void CMPEGDecControlDlg::OnOpen(int command)
{
	CFileDialog FileDlg(TRUE, 
						NULL, 
						NULL, 
						OFN_FILEMUSTEXIST, 
						"MPEG Files (*.mpg)|*.mpg| All Files (*.*)|*.*||");

    FileDlg.m_ofn.lpstrFile = m_ClipPath[command];

	char szDrive[_MAX_DRIVE];
	char szDir[_MAX_DIR];
	char szInitPath[_MAX_PATH];
	_splitpath(m_ClipPath[command], szDrive, szDir, NULL, NULL);
	sprintf(szInitPath, "%s%s", szDrive, szDir);
	FileDlg.m_ofn.lpstrInitialDir = szInitPath;
	FileDlg.m_ofn.lpstrTitle = "Open MPEG A/V Clip";

	if (FileDlg.DoModal() != IDOK) {
		return;
	}

	strcpy(m_ClipPath[command], FileDlg.GetPathName());

	ShowClipName(command);

	char szBuffer1[60];
	char szBuffer2[20];
	sprintf(szBuffer2, "ClipPath%d", command);

	CWinApp* pApp = AfxGetApp();
	pApp->WriteProfileString("Settings", PrependCardID(szBuffer1, szBuffer2), m_ClipPath[command]);
}

void CMPEGDecControlDlg::OnOpen1()
{
	OnOpen(0);
}

void CMPEGDecControlDlg::OnOpen2()
{
	OnOpen(1);
}

void CMPEGDecControlDlg::OnPlay(int command)
{
	DECODE_STATUS DecodeStatus;

	if (pMPEGDecoderControl->GetStatus(m_hStream[command], &DecodeStatus) != SUCCESS) {
												// Stream not available - assume it has stopped
		DecodeStatus.State = STATE_STOPPED;
	}			
	if (DecodeStatus.State != STATE_STOPPED) {
		OnStop(command);
	}

	m_PlayOptions[command].PlayMode = GetPlayMode(command);
	m_PlayOptions[command].StartMode = GetStartMode(command);
	GetStartOffset(command, &m_PlayOptions[command].StartOffset);
	GetEndOffset(command, &m_PlayOptions[command].EndOffset);
	GetTransitionOptions(command, &m_PlayOptions[command].TransitionOptions);
	m_PlayOptions[command].StartTime = GetStartTime(command);
	m_PlayOptions[command].AudioStreamID = GetAudioStreamID(command);

	TULSA_RESULT result = pMPEGDecoderControl->Play(m_ClipPath[command], &m_PlayOptions[command], &m_hStream[command], (LPVOID)m_pMpegStatus);

	if (result != SUCCESS) {
		char szBuffer[50];
		sprintf(szBuffer, "Play command failed.  Error code: %d", (int)result);
		AfxMessageBox(szBuffer, MB_OK);
		return;
	}
												// Send frame notification list if enabled
	if (m_bFrameListEnabled[command]) {
		pMPEGDecoderControl->NotifyAt(m_hStream[command],
			m_FrameList[command], m_FrameListCount[command], (LPVOID)m_pMpegStatus);
	}

	SetButtonsToPlayState(command);
}


void CMPEGDecControlDlg::OnPlay1()
{
	OnPlay(0);
}

void CMPEGDecControlDlg::OnPlay2()
{
	OnPlay(1);
}


void CMPEGDecControlDlg::OnStop(int command)
{
	if (m_hStream[command] == 0) {
		return;
	}
	TULSA_RESULT result = pMPEGDecoderControl->Stop(m_hStream[command]);
	SetButtonsToStopState(command);
}

void CMPEGDecControlDlg::OnStop1()
{
	OnStop(0);
}

void CMPEGDecControlDlg::OnStop2()
{
	OnStop(1);
}

void CMPEGDecControlDlg::OnPause(int command)
{
	DECODE_STATUS Status;
	TULSA_RESULT result;

	if (m_hStream[command] == 0) {
		return;
	}

	if (pMPEGDecoderControl->GetStatus(m_hStream[command], &Status) != SUCCESS) {
		return;
	}

	if (Status.State == STATE_PLAYING) {
		result = pMPEGDecoderControl->Pause(m_hStream[command]);
		SetButtonsToPlayState(command);
	} else {
		result = pMPEGDecoderControl->Resume(m_hStream[command]);
		SetButtonsToPlayState(command);
	}
}

void CMPEGDecControlDlg::OnPause1()
{
	OnPause(0);
}

void CMPEGDecControlDlg::OnPause2()
{
	OnPause(1);
}


void CMPEGDecControlDlg::OnLoop(int command)
{
	m_PlayOptions[command].bLoopPlay = !m_PlayOptions[command].bLoopPlay;
	CButton* pButton = (CButton*)GetDlgItem(CardIDs[command].LoopControl);
	pButton->SetCheck(m_PlayOptions[command].bLoopPlay? 1: 0);
}

void CMPEGDecControlDlg::OnLoop1()
{
	OnLoop(0);
}

void CMPEGDecControlDlg::OnLoop2()
{
	OnLoop(1);
}

void CMPEGDecControlDlg::OnFrameList(int command) 
{
	int i;
	CFrameListDlg dlg;

	dlg.m_bEnable = m_bFrameListEnabled[command];
	dlg.m_FrameListCount = m_FrameListCount[command];

	for (i = 0; i < MAX_FRAME_LIST_ENTRIES; i++) {
		dlg.m_FrameList[i] = m_FrameList[command][i];
	}

	if (dlg.DoModal() == IDOK) {

		m_bFrameListEnabled[command] = dlg.m_bEnable;
		m_FrameListCount[command] = dlg.m_FrameListCount;

		for (int i = 0; i < m_FrameListCount[command]; i++) {
			m_FrameList[command][i] = dlg.m_FrameList[i];
		}

		if (m_bFrameListEnabled[command]) {
			pMPEGDecoderControl->NotifyAt(m_hStream[command],
				m_FrameList[command], m_FrameListCount[command], (LPVOID)m_pMpegStatus);
		}
	}
}

void CMPEGDecControlDlg::OnFrameListA() 
{
	OnFrameList(0);
}

void CMPEGDecControlDlg::OnFrameListB() 
{
	OnFrameList(1);	
}


/////////////////////////////////////////////////////////////////////////////
// Status callback handler
/////////////////////////////////////////////////////////////////////////////
TULSA_RESULT CMPEGDecControlDlg::NotifyAtStatus(DWORD hStream, DWORD FrameNumber)
{
	int command;
	int ID;
	if (hStream == m_hStream[0]) {
		ID = IDC_FRAME_LIST_A_MSG;
		command = 0;
	} else if (hStream == m_hStream[1]) {
		ID = IDC_FRAME_LIST_B_MSG;
		command = 1;
	} else {
		return(SUCCESS);
	}
	SetDlgItemInt(ID, FrameNumber, FALSE);
	return(SUCCESS);
}



/////////////////////////////////////////////////////////////////////////////
// Init controls
/////////////////////////////////////////////////////////////////////////////
void CMPEGDecControlDlg::LoadCardButtonBitmaps(void)
{
		// load the bitmap, NOTE: delete it only when it's no longer being used.
	hBitmapPlay = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_PLAY));
	hBitmapPlayDisabled = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_PLAY_DISABLED));
		// load the bitmap, NOTE: delete it only when it's no longer being used.
	hBitmapStop = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_STOP));
	hBitmapStopDisabled = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_STOP_DISABLED));
		// load the bitmap, NOTE: delete it only when it's no longer being used.
	hBitmapPause = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_PAUSE));
	hBitmapPauseDisabled = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_PAUSE_DISABLED));
		// load the bitmap, NOTE: delete it only when it's no longer being used.
	hBitmapOpen = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_OPEN));
		// load the bitmap, NOTE: delete it only when it's no longer being used.
	hBitmapLoop = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_LOOP));
}

void CMPEGDecControlDlg::UnLoadCardButtonBitmaps(void)
{
	if (hBitmapPlay) {
		DeleteObject(hBitmapPlay);
	}
	if (hBitmapPlayDisabled) {
		DeleteObject(hBitmapPlayDisabled);
	}
	if (hBitmapStop) {
		DeleteObject(hBitmapStop);
	}
	if (hBitmapStopDisabled) {
		DeleteObject(hBitmapStopDisabled);
	}
	if (hBitmapPause) {
		DeleteObject(hBitmapPause);
	}
	if (hBitmapPauseDisabled) {
		DeleteObject(hBitmapPauseDisabled);
	}
	if (hBitmapMuteOff) {
		DeleteObject(hBitmapMuteOff);
	}
	if (hBitmapMuteOn) {
		DeleteObject(hBitmapMuteOn);
	}
	if (hBitmapOpen) {
		DeleteObject(hBitmapOpen);
	}
	if (hBitmapLoop) {
		DeleteObject(hBitmapLoop);
	}
}

void CMPEGDecControlDlg::InitCardButtons(int CG_IDD, int CG_ID_VIEW, PANEL_IDS* pIDs, int command)
{
	CButton *pButton;

	pButton = (CButton*)GetDlgItem(pIDs->PlayControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapPlay);
	pButton->EnableWindow(TRUE);

	pButton = (CButton*)GetDlgItem(pIDs->StopControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapStopDisabled);
	pButton->EnableWindow(TRUE);

	pButton = (CButton*)GetDlgItem(pIDs->PauseControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapPauseDisabled);
	pButton->EnableWindow(TRUE);

	pButton = (CButton*)GetDlgItem(pIDs->OpenControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapOpen);
	pButton->EnableWindow(TRUE);

	pButton = (CButton*)GetDlgItem(pIDs->LoopControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapLoop);
	pButton->EnableWindow(TRUE);

	pButton->SetCheck(m_PlayOptions[command].bLoopPlay? 1: 0);
}

/////////////////////////////////////////////////////////////////////////////
// Methods to update and read the controls of the dialog box...
/////////////////////////////////////////////////////////////////////////////

void CMPEGDecControlDlg::SetButtonsToPlayState(int command) 
{
	CButton* pButton;
	pButton = (CButton*)GetDlgItem(CardIDs[command].PlayControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapPlayDisabled);
	pButton = (CButton*)GetDlgItem(CardIDs[command].StopControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapStop);
	pButton = (CButton*)GetDlgItem(CardIDs[command].PauseControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapPause);
}

void CMPEGDecControlDlg::SetButtonsToStopState(int command) 
{
	CButton* pButton;

	pButton = (CButton*)GetDlgItem(CardIDs[command].PlayControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapPlay);
	pButton = (CButton*)GetDlgItem(CardIDs[command].StopControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapStopDisabled);
	pButton = (CButton*)GetDlgItem(CardIDs[command].PauseControl);
	::SendMessage(pButton->m_hWnd,BM_SETIMAGE,(WPARAM)IMAGE_BITMAP, (LPARAM)(HANDLE)hBitmapPauseDisabled);
}

void CMPEGDecControlDlg::InitButtonStates()
{
	DECODE_STATUS DecodeStatus;

	for (int i = 0; i < NUM_SUB_COMMANDS; i++) {
		if (m_hStream[i] == 0) {
			continue;
		}
		if (pMPEGDecoderControl->GetStatus(m_hStream[i], &DecodeStatus) != SUCCESS) {
												// Stream not available - assume it has stopped
			DecodeStatus.State = STATE_STOPPED;
		}			
		switch (DecodeStatus.State) {
		case STATE_STOP_REQUESTED:
		case STATE_PLAY_REQUESTED:
		case STATE_PLAY_PENDING:
		case STATE_RESUME_REQUESTED:
		case STATE_PLAYING:
			SetButtonsToPlayState(i);
			break;

		case STATE_PAUSE_REQUESTED:
		case STATE_PAUSED:
			SetButtonsToPlayState(i);
			break;

		case STATE_STOPPED:
		case STATE_ERROR:
		case STATE_UNKNOWN:
		default:
			SetButtonsToStopState(i);
			break;
		}
	}
}

void CMPEGDecControlDlg::ShowClipName(int command)
{
	char szName[_MAX_FNAME];
	char szExt[_MAX_EXT];
	char szFullName[_MAX_FNAME + _MAX_EXT];
	_splitpath(m_ClipPath[command], NULL, NULL, szName, szExt);
	sprintf(szFullName, "%s%s", szName, szExt);
	SetDlgItemText(CardIDs[command].ClipNameControl, szFullName);
}


PLAY_MODE CMPEGDecControlDlg::GetPlayMode(int command)
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(CardIDs[command].PlayModeControl);
	int sel = pCombo->GetCurSel();
	return (PLAY_MODE)sel;
}


void CMPEGDecControlDlg::SetPlayMode(int command, PLAY_MODE PlayMode)
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(CardIDs[command].PlayModeControl);
	pCombo->SetCurSel((int)PlayMode);
}

START_MODE CMPEGDecControlDlg::GetStartMode(int command)
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(CardIDs[command].StartModeControl);
	int sel = pCombo->GetCurSel();
	return (START_MODE)sel;
}

void CMPEGDecControlDlg::SetPlayMode(int command, START_MODE StartMode)
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(CardIDs[command].StartModeControl);
	pCombo->SetCurSel((int)StartMode);
}


void CMPEGDecControlDlg::GetStartOffset(int command, PMEDIA_OFFSET pOffset)
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(CardIDs[command].StartOffsetTypeControl);
	int sel = pCombo->GetCurSel();
	pOffset->Type = (OFFSET_TYPE)sel;

	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].StartOffsetHiControl);
	pEdit->GetWindowText(szBuffer, sizeof(szBuffer));
	pOffset->hi = atoi(szBuffer);

	pEdit = (CEdit*)GetDlgItem(CardIDs[command].StartOffsetLoControl);
	pEdit->GetWindowText(szBuffer, sizeof(szBuffer));
	pOffset->lo = atoi(szBuffer);
}

void CMPEGDecControlDlg::SetStartOffset(int command, PMEDIA_OFFSET pOffset)
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(CardIDs[command].StartOffsetTypeControl);
	pCombo->SetCurSel((int)pOffset->Type);

	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].StartOffsetHiControl);
	sprintf(szBuffer, "%d", pOffset->hi);
	pEdit->SetWindowText(szBuffer);

	pEdit = (CEdit*)GetDlgItem(CardIDs[command].StartOffsetLoControl);
	sprintf(szBuffer, "%d", pOffset->lo);
	pEdit->SetWindowText(szBuffer);

}

void CMPEGDecControlDlg::GetEndOffset(int command, PMEDIA_OFFSET pOffset)
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(CardIDs[command].EndOffsetTypeControl);
	int sel = pCombo->GetCurSel();
	pOffset->Type = (OFFSET_TYPE)sel;

	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].EndOffsetHiControl);
	pEdit->GetWindowText(szBuffer, sizeof(szBuffer));
	pOffset->hi = atoi(szBuffer);

	pEdit = (CEdit*)GetDlgItem(CardIDs[command].EndOffsetLoControl);
	pEdit->GetWindowText(szBuffer, sizeof(szBuffer));
	pOffset->lo = atoi(szBuffer);
}

void CMPEGDecControlDlg::SetEndOffset(int command, PMEDIA_OFFSET pOffset)
{
	CComboBox *pCombo = (CComboBox*)GetDlgItem(CardIDs[command].EndOffsetTypeControl);
	pCombo->SetCurSel((int)pOffset->Type);

	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].EndOffsetHiControl);
	sprintf(szBuffer, "%d", pOffset->hi);
	pEdit->SetWindowText(szBuffer);

	pEdit = (CEdit*)GetDlgItem(CardIDs[command].EndOffsetLoControl);
	sprintf(szBuffer, "%d", pOffset->lo);
	pEdit->SetWindowText(szBuffer);

}

void CMPEGDecControlDlg::GetTransitionOptions(int command, PTRANSITION_OPTIONS pOptions)
{
	CButton* pButton = (CButton*)GetDlgItem(CardIDs[command].TransitionBOSControl);
	pOptions->bBlankOnStartup = pButton->GetCheck();

	pButton = (CButton*)GetDlgItem(CardIDs[command].TransitionBOEOSControl);
	pOptions->bBlankOnEOS = pButton->GetCheck();

	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].TransitionFramesControl);
	pEdit->GetWindowText(szBuffer, sizeof(szBuffer));
	pOptions->TransitionFrames = atoi(szBuffer);
}


void CMPEGDecControlDlg::SetTransitionOptions(int command, PTRANSITION_OPTIONS pOptions)
{
	CButton* pButton = (CButton*)GetDlgItem(CardIDs[command].TransitionBOSControl);
	pButton->SetCheck(pOptions->bBlankOnStartup? 1: 0);

	pButton = (CButton*)GetDlgItem(CardIDs[command].TransitionBOEOSControl);
	pButton->SetCheck(pOptions->bBlankOnEOS? 1: 0);

	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].TransitionFramesControl);
	sprintf(szBuffer, "%d", pOptions->TransitionFrames);
	pEdit->SetWindowText(szBuffer);
}

void CMPEGDecControlDlg::SetStartTime(int command, DWORD StartTime)
{
	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].StartTimeControl);
	sprintf(szBuffer, "%d", StartTime);
	pEdit->SetWindowText(szBuffer);
}

DWORD CMPEGDecControlDlg::GetStartTime(int command)
{
	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].StartTimeControl);
	pEdit->GetWindowText(szBuffer, sizeof(szBuffer));
	return atoi(szBuffer);
}

void CMPEGDecControlDlg::SetAudioStreamID(int command, DWORD StreamID)
{
	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].AudioStreamIDControl);
	sprintf(szBuffer, "%d", StreamID);
	pEdit->SetWindowText(szBuffer);
}

DWORD CMPEGDecControlDlg::GetAudioStreamID(int command)
{
	char szBuffer[50];
	CEdit* pEdit = (CEdit*)GetDlgItem(CardIDs[command].AudioStreamIDControl);
	pEdit->GetWindowText(szBuffer, sizeof(szBuffer));
	return atoi(szBuffer);
}



char* CMPEGDecControlDlg::PrependCardID(char* buffer, char* string)
{
	sprintf(buffer, "Card%d%s", m_CardNumber, string);
	return(buffer);
}

